library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
entity Hamming is
    Port ( clk : in std_logic;
           din : in std_logic_vector(23 downto 0);
           cc_ecc : in std_logic;
           dout : out std_logic_vector(19 downto 0);
           cc_rxena : in std_logic);
end Hamming;

architecture my_arch of Hamming is
signal din_q: std_logic_vector(23 downto 0);
signal d: std_logic_vector(21 downto 1);
signal q: std_logic_vector(20 downto 1);
signal sum_a: std_logic_vector(1 downto 0);
signal sum_b: std_logic_vector(1 downto 0);
signal sum: std_logic_vector(2 downto 0);
signal pp: std_logic;
signal q18_q: std_logic;
--signal dout_i: std_logic_vector(19 downto 0);
begin
d <= din_q(20 downto 14) & din_q(22) & din_q(12 downto 6) &  din_q(21) & din_q(4 downto 0);
process(clk)
begin
  if(clk'event and clk = '1')then
     din_q <= din;
	 q(1) <= d(3);
	 q(2) <= d(5);
	 q(3) <= d(6);
	 q(4) <= d(7);
	 q(5) <= d(9);
	 q(6) <= d(10);
	 q(7) <= d(11);
	 q(8) <= d(12);
	 q(9) <= d(13);
	 q(10) <= d(14);
	 q(11) <= d(15);
	 q(12) <= d(17);
	 q(13) <= d(18);
	 q(14) <= d(19);
	 q(15) <= d(20);
	 q(16) <= d(21);
	 q(17) <= '0';
	 q(18) <= sum(2) or (sum(1) and sum(0));
	 q(19) <= (sum(2) and not sum(0)) or (not sum(2) and not sum(1) and sum(0));
	 q(20) <= not sum(2) and sum(1);
     q18_q <= q(18);
     dout(15 downto 0) <= q(16 downto 1);
     dout(19 downto 17) <= q(20 downto 18);
     dout(16) <= q(18) xor q18_q;
  end if;
end process;
process(d)
begin
end process;
sum_a(1) <= (d(1) and d(2)) or (d(1) and d(4)) or (d(2) and d(4));
sum_a(0) <= d(1) xor d(2) xor d(4);
sum_b(1) <= d(8) and d(16);
sum_b(0) <= d(8) xor d(16);
sum(2) <= (sum_a(1) and sum_b(1)) or (sum_a(1) and sum_a(0) and sum_b(0));
sum(1) <= sum_a(1) xor sum_b(1) xor (sum_a(0) and sum_b(0));
sum(0) <= sum_a(0) xor sum_b(0);
--dout <= dout_i;
end my_arch;
