library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
entity par_chk is
    Port ( AD : in std_logic_vector(31 downto 0);
	       nCBE : in std_logic_vector(3 downto 0);
           adr_par : in std_logic;
           par : in std_logic;
           clk : in std_logic;
           clk_en : in std_logic;
           perr_chk : in std_logic;
           serr_ena : in std_logic;
           PAR_ERR : out std_logic;
           SERR_OUT : out std_logic);
end par_chk;
architecture my_arch of par_chk is
signal PAR_nCBE : std_logic;
signal PAR_AD : std_logic_vector(9 downto 0);
signal PAR_GEN : std_logic;
begin
process(clk)
begin
  if(clk'event and clk = '1')then
    PAR_nCBE <= nCBE(0) xor nCBE(1) xor nCBE(2) xor nCBE(3);
    for i in 0 to 7 loop
      PAR_AD(i) <= AD(i*4) xor AD(i*4+1) xor AD(i*4+2) xor AD(i*4+3);
	end loop;
	PAR_AD(8) <= PAR_AD(0) xor PAR_AD(1) xor PAR_AD(2) xor PAR_AD(3);
	PAR_AD(9) <= PAR_AD(4) xor PAR_AD(5) xor PAR_AD(6) xor PAR_AD(7);
	PAR_GEN <= PAR_nCBE xor PAR_AD(8) xor PAR_AD(9);
	if(clk_en = '1')then
	  PAR_ERR <= (PAR_GEN xor par) and perr_chk;
	end if;
  end if;
end process;
process(clk,serr_ena)
begin
  if(serr_ena = '0')then
    SERR_OUT <= '0';
  elsif(clk'event and clk = '1')then
	if(clk_en = '1')then
	  SERR_OUT <= (PAR_GEN xor par) and adr_par;
	end if;
  end if;
end process;
end my_arch;
